//+---------------------------------------------------------------------------+
//|                         DO NOT DELETE THIS HEADER                         |
//|               DELETING THIS HEADER INFRINGES COPYRIGHT LAWS               |
//|                  Copyright 2020, Trade View Investments                   |
//|                       https://www.tradeview.com.au                        |
//|                                                                           |
//|        THIS ALGORITHM HAS BEEN GENERATED USING BUILDER Copyright 2020     |
//|                                                                           |
//| Warranties and Acknowledgements                                           |
//|                                                                           |
//| TVI warrant that its software will be provided                            |
//| with reasonable skill and care.                                           |
//| TVI makes no other warranties about its software.                         |
//| Trade View Investments will not be liable in any way for any loss         |
//| or damage suffered by you through use or access to this software          |
//| By continuing to access or use this Website, or any Service or            |
//| Software you affirm your 'acceptance' of these Terms                      |
//| https://www.tradeview.com.au/terms-conditions/                            |
//|                                                                           |
//| Copyright                                                                 |
//|                                                                           |
//| The software is the property of Trade View Investments Pty Ltd.           |
//| This software is provided for your personal use only and should not       |
//| be distributed or transmitted to any third party, in whole or in part,    |
//| without the prior written consent of Trade View Investments Pty Ltd.      |
//|                                                                           |
//| Risk Warning                                                              |
//|                                                                           |
//| Leveraged derivative products carry a high level of risk to your capital. |
//| You should only risk capital that you can afford to lose.                 |
//| In certain circumstances due to fluctuations in value you may not         |
//| get back your initial investment amount.                                  |
//| You may not only lose your initial investment but you may also            |
//| incur a liability to pay a further amount.                                |
//| Leveraged products are only suitable for investors who                    |
//| understand the risks associated with such products and may                |
//| not be suitable for all investors, you should ensure that you fully       |
//| understand the risks involved, and seek independent advice if necessary.  |
//|                                                                           |
//|             USING THE ALGORITHM CREATED BY BUILDER IS AT YOUR OWN RISK    |
//|                         DO NOT DELETE THIS HEADER                         |
//|               DELETING THIS HEADER INFRINGES COPYRIGHT LAWS               |
//|                                                                           |
//+---------------------------------------------------------------------------+
//+------------------------------------------------------------------
//| Enums
//+------------------------------------------------------------------
enum ENUM_ORDER_SELECTOR_TOP_BOTTOM {
    TAKE_ALL, TAKE_TOP, TAKE_BOTTOM
};

enum ENUM_ORDER_SELECTOR_DIRECTION {
    DIRECTION_ANY, DIRECTION_LONG, DIRECTION_SHORT
};

enum ENUM_ORDER_SELECTOR_ORDER_BY {
    ORDER_BY_POSITION,
    ORDER_BY_AGE,
    ORDER_BY_POINTS,
    ORDER_BY_PROFIT,
    ORDER_BY_OPENPRICE,
    ORDER_BY_LOTS,
    ORDER_BY_TAKE_PROFIT,
    ORDER_BY_STOP_LOSS,
    ORDER_BY_NONE
};

enum ENUM_ORDER_COUNT_PNL {
  PNL_ANY, PNL_PROFIT, PNL_LOSS,
};

enum ENUM_SLTP {
    STOP_LOSS, TAKE_PROFIT
};

enum ENUM_ADJUST {
    ADJUST_PRICE, ADJUST_FROM_MARKET, ADJUST_FROM_CURRENT, ADJUST_FROM_OPEN
};

enum ENUM_CHANGE_TYPE {
  CHANGE_CLOSER, CHANGE_FURTHER, CHANGE_ANY
};

enum ENUM_SLTP_TYPE{
  SLTP_PRICE, SLTP_POINTS
};

enum ENUM_DAY {
  DAY_SUNDAY = 0,
  DAY_MONDAY = 1,
  DAY_TUESDAY = 2,
  DAY_WEDNESDAY = 3,
  DAY_THURSDAY = 4,
  DAY_FRIDAY = 5,
  DAY_SATURDAY = 6
};

//+------------------------------------------------------------------
//| Variables
//+------------------------------------------------------------------

double ATR_SELL = 0; // ATR SELL
bool BE_ON = true; // BE ON
double ATR = 0; // ATR
double ATR_BUY = 0; // ATR BUY
extern double risk_percentage = 1; // risk percentage
const string _symbol = Symbol();
input int MagicNumber = 317673221;
input int OpenSlippage = 5;
input int CloseSlippage = 5;
input bool AdjustSizeLong = true;
input bool AdjustSizeShort = true;

//+------------------------------------------------------------------
//| Expert tick function
//+------------------------------------------------------------------
void OnTick() {
  if( !IsTradeAllowed() )  return;
  //--- ON BAR ---
  if( NewBar() ) {
    if (iMA(_symbol,PERIOD_CURRENT,10,0,MODE_SMMA,PRICE_CLOSE,1) > iMA(_symbol,PERIOD_CURRENT,60,0,MODE_SMMA,PRICE_CLOSE,1)) {
      if (iCustom(_symbol,PERIOD_CURRENT,"Stoploss_Index",2,2) < iCustom(_symbol,PERIOD_CURRENT,"Stoploss_Index",3,2)) {
        if (iCustom(_symbol,PERIOD_CURRENT,"Stoploss_Index",2,1) > iCustom(_symbol,PERIOD_CURRENT,"Stoploss_Index",3,1)) {
          // Long
          PlaceOrder(MagicNumber, OpenSlippage, AdjustSizeLong, OP_BUY, 0.01, _symbol, SLTP_POINTS, 0, SLTP_POINTS, 0, "Long", 0x990000);
        }
      }
    }
    if (iMA(_symbol,PERIOD_CURRENT,10,0,MODE_SMMA,PRICE_CLOSE,1) < iMA(_symbol,PERIOD_CURRENT,60,0,MODE_SMMA,PRICE_CLOSE,1)) {
      if (iCustom(_symbol,PERIOD_CURRENT,"Stoploss_Index",2,2) > iCustom(_symbol,PERIOD_CURRENT,"Stoploss_Index",3,2)) {
        if (iCustom(_symbol,PERIOD_CURRENT,"Stoploss_Index",2,1) < iCustom(_symbol,PERIOD_CURRENT,"Stoploss_Index",3,1)) {
          // Short
          PlaceOrder(MagicNumber, OpenSlippage, AdjustSizeShort, OP_SELL, 0.01, _symbol, SLTP_POINTS, 0, SLTP_POINTS, 0, "Short", 0x0000ff);
        }
      }
    }
    if (iCustom(_symbol,PERIOD_CURRENT,"Stoploss_Index",2,2) < iCustom(_symbol,PERIOD_CURRENT,"Stoploss_Index",3,2)) {
      if (iCustom(_symbol,PERIOD_CURRENT,"Stoploss_Index",2,1) > iCustom(_symbol,PERIOD_CURRENT,"Stoploss_Index",3,1)) {
        for ( int i_0 = OrdersTotal() - 1; i_0 >= 0; i_0-- )  {
          if ( !OrderSelect(i_0, SELECT_BY_POS, MODE_TRADES) ) continue;
          if ( OrderType() != OP_BUY && OrderType() != OP_SELL ) continue;
          if ( OrderMagicNumber() != MagicNumber ) continue;
          if( OrderSymbol() != _symbol ) continue;
          if (OrderType() != OP_SELL) continue;
          CloseOrder(MagicNumber, CloseSlippage, OrderTicket(), OrderType(), OrderLots(), OrderSymbol(), OrderComment(), 0x00cc33);
        }
      }
    }
    if (iCustom(_symbol,PERIOD_CURRENT,"Stoploss_Index",2,2) > iCustom(_symbol,PERIOD_CURRENT,"Stoploss_Index",3,2)) {
      if (iCustom(_symbol,PERIOD_CURRENT,"Stoploss_Index",2,1) < iCustom(_symbol,PERIOD_CURRENT,"Stoploss_Index",3,1)) {
        for ( int i_1 = OrdersTotal() - 1; i_1 >= 0; i_1-- )  {
          if ( !OrderSelect(i_1, SELECT_BY_POS, MODE_TRADES) ) continue;
          if ( OrderType() != OP_BUY && OrderType() != OP_SELL ) continue;
          if ( OrderMagicNumber() != MagicNumber ) continue;
          if( OrderSymbol() != _symbol ) continue;
          if (OrderType() != OP_BUY) continue;
          CloseOrder(MagicNumber, CloseSlippage, OrderTicket(), OrderType(), OrderLots(), OrderSymbol(), OrderComment(), 0x00cc33);
        }
      }
    }
  }
  //--- ON TICK ---
}

double OrderPoints(const string symbol, const long orderType, const double orderOpen) {
  if (orderType == OP_BUY) return ConvertToPoints(symbol, MarketInfo(OrderSymbol(), MODE_BID) - orderOpen);
  else if (orderType == OP_SELL) return ConvertToPoints(symbol, orderOpen - MarketInfo(OrderSymbol(), MODE_ASK));
  return 0;
}

#import "TVI_Builder_MT4_4_5.ex4"
  void OrdersSortBy( const int magic_no, const string filter_symbol, const ENUM_ORDER_SELECTOR_TOP_BOTTOM sort_type, const int sort_num, const ENUM_ORDER_SELECTOR_DIRECTION filter_direction, const ENUM_ORDER_SELECTOR_ORDER_BY order_by, int& tickets[] );
  int OrdersCount( const int magic_no, const string filter_symbol, const ENUM_ORDER_SELECTOR_DIRECTION filter_direction, const ENUM_ORDER_COUNT_PNL filter_pnl );
  int PlaceOrder( const int magic_no, const int openSlippage, const bool adjustLots, const int op_type, double lots, const string symbol, const ENUM_SLTP_TYPE sl_type, const double sl_value, const ENUM_SLTP_TYPE tp_type, const double tp_value, const string comment, const color clr);
  bool CloseOrder( const int magic_no, const int closeSlippage, const int ticket, const int type, const double lots, const string symbol, const string comment, const color clr );
  bool ModifySLTP( const int magic_no, const int ticket, const int type, const string symbol, const double open_price, const double stop_loss, const double take_profit, const string comment, const ENUM_SLTP sltp, const ENUM_ADJUST adjust, const double value, const ENUM_CHANGE_TYPE changeType);
  bool IsTradingDay( const bool tradeMonday, const bool tradeTuesday, const bool tradeWednesday, const bool tradeThursday, const bool tradeFriday, const bool tradeSaturday, const bool tradeSunday );
  bool IsTradingHour( const string tradeStartTime, const string tradeEndTime );
  bool IsDayOfWeek( const ENUM_DAY dayOfWeek );
  bool NewBar();
  double ConvertToPoints(const string symbol, const double value);
#import
